<?php

namespace FiloBlu\StockaFix\Ui\Component\Listing;

/**
 * Class Columns
 * @package FiloBlu\StockaFix\Ui\Component\Listing
 */
class Columns extends \Magento\Ui\Component\Listing\Columns
{
    /**
     * @var int
     */
    const DEFAULT_COLUMNS_MAX_ORDER = 1;

    /**
     * @var \Magento\Framework\App\RequestInterface
     */
    protected $request;

    /**
     * @var \Magento\Framework\View\Element\UiComponentFactory
     */
    protected $uiComponentFactory;
    /**
     * @var \Magento\Framework\App\ResourceConnection
     */
    protected $resourceConnection;

    /**
     * @var \FiloBlu\StockaFix\Model\ResourceModel\Report\CollectionFactory
     */
    protected $reportCollectionFactory;

    /**
     * @var \FiloBlu\StockaFix\Helper\ReportHelper
     */
    protected $reportHelper;

    /**
     * Columns constructor.
     * @param \Magento\Framework\View\Element\UiComponent\ContextInterface $context
     * @param \Magento\Framework\App\RequestInterface $request
     * @param \Magento\Framework\View\Element\UiComponentFactory $uiComponentFactory
     * @param \Magento\Framework\App\ResourceConnection $resourceConnection
     * @param \FiloBlu\StockaFix\Model\ResourceModel\Report\CollectionFactory $reportCollectionFactory
     * @param \FiloBlu\StockaFix\Helper\ReportHelper $reportHelper
     * @param array $components
     * @param array $data
     */
    public function __construct(
        \Magento\Framework\View\Element\UiComponent\ContextInterface $context,
        \Magento\Framework\App\RequestInterface $request,
        \Magento\Framework\View\Element\UiComponentFactory $uiComponentFactory,
        \Magento\Framework\App\ResourceConnection $resourceConnection,
        \FiloBlu\StockaFix\Model\ResourceModel\Report\CollectionFactory $reportCollectionFactory,
        \FiloBlu\StockaFix\Helper\ReportHelper $reportHelper,
        array $components = [],
        array $data = []
    )
    {
        $this->uiComponentFactory = $uiComponentFactory;
        $this->request = $request;
        $this->resourceConnection = $resourceConnection;
        $this->reportCollectionFactory = $reportCollectionFactory;
        $this->reportHelper = $reportHelper;
        parent::__construct($context, $components, $data);
    }

    /**
     * {@inheritdoc}
     */
    public function prepare()
    {
        $columnSortOrder = self::DEFAULT_COLUMNS_MAX_ORDER;

        $id = $this->request->getParam('id');

        /** @var \FiloBlu\StockaFix\Model\Report $report */

        $report = $this->reportCollectionFactory->create()->addFieldToFilter('report_id', ['eq', $id])->getFirstItem();

        $meta = $this->reportHelper->getReportMeta($report);


        /*
         * Add reportoutput_id
         */

      /*  if (!isset($this->components['reportoutput_id'])) {
            $arguments = [
                'data' => [
                    'config' => [
                        'label' => 'reportoutput_id',
                        'dataType' => 'text',
                        'add_field' => false,
                        'visible' => 1,
                        'filter' => 'text',
                        'sortOrder' => ++$columnSortOrder,
                        'component' => 'Magento_Ui/js/grid/columns/column'
                    ]
                ],
                'context' => $this->context
            ];
            $column = $this->uiComponentFactory->create('reportoutput_id', 'column', $arguments);
            $column->prepare();
            $this->addComponent('reportoutput_id', $column);
        }
*/
        foreach ($meta as $attribute => $info) {
            if (!isset($this->components[$attribute])) {
                $arguments = [
                    'data' => [
                        'config' => [
                            'label' => $attribute,
                            'dataType' => 'text',
                            'add_field' => false,
                            'visible' => 1,
                            'filter' => 'text',
                            'sortOrder' => ++$columnSortOrder,
                            'component' => 'Magento_Ui/js/grid/columns/column'
                        ]
                    ],
                    'context' => $this->context
                ];
                $column = $this->uiComponentFactory->create($attribute, 'column', $arguments);
                $column->prepare();
                $this->addComponent($attribute, $column);
            }
        }
        parent::prepare();
    }

}
